 /***************************************************************
 *                                                              *  
 *    o_gfxfile.h                                               *
 *    Graphic file loading and writting                         *
 *                                                              *
 *    (G) corTeX / Optimum   1999-05-13                         *
 *    http://www.citeweb.net/optimum                            *
 *                                                              *
 *    (G) Gnu GPL                                               *
 ***************************************************************/

/*
 * This part of optilib requires :  / compilation flag
 * libjepg                           -ljpeg
 * libpng                            -lpng
 *
 * If experiencing compilation/linking problems with png,
 * try getting the lattest png library at
 * http://unix.hensa.ac.uk/pub/gopher/pub/png/home/
 *
 * I use libpng 1.0.3, that is  libpng.so.2.1.0.3
 *
 */




#ifndef O_GFXFILE_H
#define O_GFXFILE_H

#include <stdio.h>

#ifndef NO_JPEG
#include "jpeglib.h"
#endif

#ifndef NO_PNG
#include <png.h>
#endif

#include "o_std.h"
#include "o_types.h"
#include "o_surface.h"
#include "o_gfxm.h"
#include "o_convert.h"


#ifndef NO_JPEG

/******************************************/
/* JPEG loader into an ot_simple_surface  */
// ( XXX have to do :if GfxMode is PAL_8, asks jpeglib to perform quantization)
ot_simple_surface *ofn_JpegLoad(const char *fileName, int GfxMode);

// Write a jpeg file with the image in ot_simple_surface.
// (note : jpeg is always truecolor, so palette image will be
// expanded )
void ofn_JpegWrite(const char *fileName, ot_simple_surface *Os);

#endif



#ifndef NO_PNG

/**********************************/
/* PNG loader into an ot_surface  */
// same return as jpeg
// PAL_8 is valid only if the png file IS a palettized image.

ot_simple_surface *ofn_PngLoad(const char *fileName, int GfxMode);


#endif  


#endif





