
 /***************************************************************
 *                                                              *  
 *    o_schedule.c                                              *
 *    Time utilities                                            *
 *                                                              *
 *    (G) corTeX / Optimum   1999-02-04                         *
 *    http://www.citeweb.net/optimum                            *
 *                                                              *
 *    (G) Gnu GPL                                               *
 ***************************************************************/


#include "o_schedule.h"

void ofn_sched_init(ot_time *Ot){
  gettimeofday( &(Ot->demo_start_time), NULL);
  Ot->sequence_start_time = 
           Ot->frame_time = 
    Ot->demo_current_time = Ot->demo_start_time;

  timerclear( &(Ot->demo_elapsed_time));
  timerclear( &(Ot->frame_elapsed_time));
}

void ofn_sched_update(ot_time *Ot){
  gettimeofday( &(Ot->demo_current_time), NULL);
  ofn_diff_timeval( &(Ot->demo_start_time),
		     &(Ot->demo_current_time),
		     &(Ot->demo_elapsed_time));

  ofn_diff_timeval( &(Ot->sequence_start_time),
		     &(Ot->demo_current_time),
		     &(Ot->sequence_elapsed_time));
} 
                               
void ofn_sched_nextframe(ot_time *Ot){
  struct timeval frame_tmp;
  
  gettimeofday( &frame_tmp, NULL);
  ofn_diff_timeval(&(Ot->frame_time),
		    &frame_tmp,
		    &(Ot->frame_elapsed_time));
  Ot->frame_time=frame_tmp;

}

void ofn_sched_nextsequence(ot_time *Ot){
  gettimeofday( &(Ot->sequence_start_time), NULL);
  timerclear (&(Ot->sequence_elapsed_time));
}


float ofn_scale_time(float secscale,struct timeval*elapsed){
  return (secscale * elapsed->tv_sec + secscale * elapsed->tv_usec / 1000000);
}

void  ofn_diff_timeval(struct timeval*old, struct timeval*new,
			    struct timeval*dst){
  dst->tv_sec = new->tv_sec - old->tv_sec; 
  if (new->tv_usec > old->tv_usec)
    dst->tv_usec = new->tv_usec - old->tv_usec; 
  else {
    dst->tv_usec = 1000000+ new->tv_usec - old->tv_usec; 
    dst->tv_sec--;
  }
}






